import request from '@/utils/request';
import type {ApiResult, PageResult} from '@/api';
import type {HistorySettle, HistorySettleParam} from './model';

/**
 * 分页查询结算
 */
export async function pageHistorySettle(params: HistorySettleParam) {
  const res = await request.get<ApiResult<PageResult<HistorySettle>>>(
    '/tower/tower-history-settle/page',
    {
      params
    }
  );
  if (res.data.code === 0) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 查询合同列表
 */
export async function listHistorySettle(params?: HistorySettleParam) {
  const res = await request.get<ApiResult<HistorySettle[]>>(
    '/tower/tower-history-settle',
    {
      params
    }
  );
  if (res.data.code === 0 && res.data.data) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 根据id查询合同
 */
export async function getHistorySettle(id: number) {
  const res = await request.get<ApiResult<HistorySettle>>(
    '/tower/tower-history-settle/' + id
  );
  if (res.data.code === 0 && res.data.data) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 添加合同
 */
export async function addHistorySettle(data: HistorySettle) {
  const res = await request.post<ApiResult<unknown>>(
    '/tower/tower-history-settle',
    data
  );
  if (res.data.code === 0) {
    return res.data;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 修改合同
 */
export async function updateHistorySettle(data: HistorySettle) {
  const res = await request.put<ApiResult<unknown>>(
    '/tower/tower-history-settle',
    data
  );
  if (res.data.code === 0) {
    return res.data;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 批量修改合同
 */
export async function updateBatchHistorySettle(data: HistorySettle[]) {
  const res = await request.put<ApiResult<unknown>>(
    '/tower/tower-history-settle/batch',
    data
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}
export async function addBatchHistorySettle(data: HistorySettle[]) {
  const res = await request.post<ApiResult<unknown>>(
    '/tower/tower-history-settle/batch',
    data
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 删除合同
 */
export async function removeHistorySettle(id?: number) {
  const res = await request.delete<ApiResult<unknown>>(
    '/tower/tower-history-settle/' + id
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 批量删除合同
 */
export async function removeBatchHistorySettle(data: (number | undefined)[]) {
  const res = await request.delete<ApiResult<unknown>>(
    '/tower/tower-history-settle/batch',
    {
      data
    }
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}
